/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2007 N.Le Corre - nicolas.lecorre@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.controls.paye;

import java.util.Hashtable;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

import fr.gouv.finances.cp.xemelios.controls.AbstractUnitControl;
import fr.gouv.finances.cp.xemelios.controls.Anomalie;
import fr.gouv.finances.cp.xemelios.controls.IdGenerator;
import fr.gouv.finances.cp.xemelios.controls.Node;

public class PAY17 extends AbstractUnitControl {
	private final static Logger logger = Logger.getLogger(PAY17.class);
    public static final transient String CTRL_ID = PAY17.class.getSimpleName();
	private Vector<Anomalie> anos = new Vector<Anomalie>();
	private String docId = null;

	
	private static final String ON_RETURN_ANOMALIES = "DocumentPaye/";
	private static final String CHEMIN_PK_ANNEE = "DocumentPaye/Annee/";
	private static final String CHEMIN_PK_MOIS = "DocumentPaye/Mois/";
//	private static final String CHEMIN_DOCUMENT = "DocumentPaye/";
	private static final String CHEMIN_SIRET = "DocumentPaye/Employeur/Siret/";
	private String refNodeId = "";
	private String pk_annee = "", pk_mois = "", pk_siret = "";


	private static final String REPLACE_FICHIER = "##FICHIER##";
	private static final String REPLACE_CORRECT_FICHIER = "##CORRECT_FICHIER##";
	
	public void startDocument() throws SAXException {
		logger.info("In "+CTRL_ID);
	}
	
	public void setDocId(String docID) {
		this.docId = docID;		
	}

	public void startElement(String uri, String localName, String qName, Attributes atts, String xpath) throws SAXException {
//		if (xpath.endsWith(CHEMIN_DOCUMENT)) {
//			refNodeId = atts.getValue("ano:node-id");
//		} else 
            if (xpath.endsWith(CHEMIN_PK_ANNEE)) {
                    pk_annee = atts.getValue("V");
            } else if (xpath.endsWith(CHEMIN_PK_MOIS)) {
                    pk_mois = atts.getValue("V");
            } else if (xpath.endsWith(CHEMIN_SIRET)) {
                    pk_siret = atts.getValue("V");
            }
	}

	public Vector<Anomalie> endElement(String uri, String localName, String qName, String xpath) throws SAXException {
		if (xpath.endsWith(ON_RETURN_ANOMALIES)) {
			// TEST
			boolean erreur = false;
			String idealFileName = pk_siret+"-"+pk_annee+"-ETAT_PAYE-"+pk_mois+".xhl";
			if (!idealFileName.equals(getFileName())) erreur = true;
			// ANOMALIE
			if (erreur) {
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(REPLACE_FICHIER, getFileName());
				msg = msg.replaceAll(REPLACE_CORRECT_FICHIER, idealFileName);
//				String path = ""; // path est vide de façon à ne pas avoir de lien sous l'anomalie. 
				String anoId = IdGenerator.nextId();
				String libelleLien = "";
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "Paye");
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
											getDocumentModel().getControlById(CTRL_ID).getId(),
											getDocumentModel().getControlById(CTRL_ID).getLibelle(),
											getDocumentModel().getDocumentId(),
											"etatPaye",
											"payeIndivMensuel", // élément importable
											refNodeId, // id élément importable
											localName,
											libelleLien,
											msg,
											getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
											getDocumentModel().getControlById(CTRL_ID).getSeverity(),
											null, // xpath vers le bordereau sous lequel se trouve l'anomalie
											xslParams); // paramètres supplémentaires pour accéder à l'élément en anomalie
				ano.addNode(new Node(refNodeId));
				anos.add(ano);
				return anos;
			} else {
				return null;
			}
		} else
			return null;
	}

	public void characters(char[] ch, int start, int length, String xpath)
			throws SAXException {
		// TODO Raccord de méthode auto-généré

	}

	public void endDocument() throws SAXException {
		// TODO Raccord de méthode auto-généré

	}

	public void endPrefixMapping(String prefix, String xpath)
			throws SAXException {
		// TODO Raccord de méthode auto-généré

	}

	public void ignorableWhitespace(char[] ch, int start, int length,
			String xpath) throws SAXException {
		// TODO Raccord de méthode auto-généré

	}

	public void processingInstruction(String target, String data, String xpath)
			throws SAXException {
		// TODO Raccord de méthode auto-généré

	}

	public void setDocumentLocator(Locator locator) {
		// TODO Raccord de méthode auto-généré

	}

	public void setParameters(Hashtable<String, Object> params) {
		// TODO Raccord de méthode auto-généré

	}

	public void skippedEntity(String name, String xpath) throws SAXException {
		// TODO Raccord de méthode auto-généré

	}

	public void startPrefixMapping(String prefix, String uri, String xpath)
			throws SAXException {
		// TODO Raccord de méthode auto-généré

	}

}
